﻿function saveAs()
{
  // XPCOM for Mozilla-based browsers
  try {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    
    // This code snippet (modified) from http://developer.mozilla.org/en/docs/nsIFilePicker#Example
    var nsIFilePicker = Components.interfaces.nsIFilePicker;

    var fp = Components.classes["@mozilla.org/filepicker;1"]
    	           .createInstance(nsIFilePicker);
    fp.init(window, "Grade Book Save As", nsIFilePicker.modeSave);
    fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

    var rv = fp.show();
    if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
      var file = fp.file;
      // Get the path as string. Note that you usually won't 
      // need to work with the string paths.
      var path = fp.file.path;
      // work with returned nsILocalFile...
      
      
      json.file_path = fp.file.path;
      if (json.document_title == "Untitled")
        if (file.leafName.indexOf(".") == -1)
          json.document_title = file.leafName
        else
          json.document_title = file.leafName.substring(0,file.leafName.lastIndexOf("."));

      save();
    }
  } catch(e) {
    notify(e);
  }
}

function openFile()
{/*
  el("open_button").disabled = true;
  el("open").style.display = "block";
  el("open").onsubmit = openFile;
  el("open_file").focus();
  el("open_file").select();*/
  
  // XPCOM for Mozilla-based browsers
  try {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    
    // This code snippet from http://developer.mozilla.org/en/docs/nsIFilePicker#Example
    var nsIFilePicker = Components.interfaces.nsIFilePicker;

    var fp = Components.classes["@mozilla.org/filepicker;1"]
    	           .createInstance(nsIFilePicker);
    fp.init(window, "Open File in Grade Book", nsIFilePicker.modeOpen);
    fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

    var rv = fp.show();
    if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
      var file = fp.file;
      // Get the path as string. Note that you usually won't 
      // need to work with the string paths.
      var path = fp.file.path;
      // work with returned nsILocalFile...
      
      importData(xpcomFileRead(fp.file.path));
      el("sourcecode").value = xpcomFileRead(fp.file.path);
      //document.title = file.leafName + " - Grade Book";
    }
  } catch(e) {
  }
}



// All code below taken from (with minor modifications) : http://www.faqts.com/knowledge_base/view.phtml/aid/23360/fid/53

// To perform local file IO from JavaScript in Mozilla, use the XPCOM nsIFile file IO library. See the above references for more details.
function xpcomFileWrite(filePath, content) {
  /*if (filePath == "new") saveAs()
  else*/
	try {

    if (Components) {	// XPConnect 'Components' object check.
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
            		// Get file component.
			var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      
			file.initWithPath(filePath);
			if (!file.exists()) {
				alert('Creating new file ' + filePath);
/********************************************************************
create(type, permissions)
This function will create a new file or directory in the file system.
Any nodes that have not been created or resolved, will be. If the file
or directory already exists create() will return
NS_ERROR_FILE_ALREADY_EXISTS.
Arguments:
type: This specifies the type of file system object to be made. The
only two types at this time are file and directory/folder which are:
	NORMAL_FILE_TYPE = 0x00
	DIRECTORY_TYPE   = 0x01
If the type is unrecongnized, we will return an error
(NS_ERROR_FILE_UNKNOWN_TYPE).
permissions: The unix style octal permissions. This may be ignored on
systems that do not need to do permissions. In general, permissions are
based on three octal numbers. The first specifies the access for the
user, the second for the group and the last for others.
	0 - No permission to read, write or execute.
	1 - Execute permission only.
	2 - Write permission only.
	3 - Execute and write permission.
	4 - Read permission only.
	5 - Execute and read permission.
	6 - Write and read permission.
	7 - Execute, write and read permission.
User read/write, group read, others read would be 644
********************************************************************/
				file.create(0x00, 0644);
			}
    
			// Write with nsIFileOutputStream.
			var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
/********************************************************************
init(), opens a file for reading, writing, or both.
INPUTS:
1.	The path name of the file to be opened
2.	The file status IO flag. It is a bitwise OR of the following 
bit flags (only one of the first three flags below may be used):
		0x01 - Open for reading only.
		0x02 - Open for writing only.
		0x04 - Open for reading and writing.
		0x08 - If the file does not exist, the file is created. 
If the file exists, this flag has no effect.
		0x10 - If set, each write will wait for both the file 
data and file status to be physically updated.
		0x20 - The file pointer is set to the end of the file 
prior to each write.
		0x40 - If the file exists, its length is truncated to 0.
		0x80 - If the file does not exist, the file is created.
	If the file already exists, no action and NULL is returned.
3.	The access permission bits of the file 'mode'.
	CAVEAT: 'mode' is currently only applicable on UNIX platforms. 
The 'mode' argument may be ignored on other platforms.
		00400 - Read by owner.
		00200 - Write by owner.
		00100 - Execute (search if a directory) by owner.
		00040 - Read by group.
		00020 - Write by group.
		00010 - Execute by group.
		00004 - Read by others.
		00002 - Write by others
		00001 - Execute by others.
4.	Behavior flags specifying various behaviors of the class 
(currently not supported).
********************************************************************/
			outputStream.init(file, 0x20 | 0x02, 00004, null);
			outputStream.write(content, content.length);
			outputStream.flush();
			outputStream.close();
			return true;

    }
  } catch(e) {
		notify(e);
		return false;
	}
	return false;
}

function xpcomFileRead(filePath) {
	try {
    if (Components) {
		
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
			var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
			file.initWithPath(filePath);
			if (!file.exists()) {
				alert(filePath+'\n\nFile does not exist');
				return false;
			}
			var inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
			inputStream.init(file, 0x01, 00004, null);
			var sInputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
			sInputStream.init(inputStream);
			return sInputStream.read(sInputStream.available());
		}
	} catch(e) {
		//alert(e);
		return false;
	}
	return false;
}